'use strict';

var lezerFiz = require('@formulavize/lezer-fiz');
var language = require('@codemirror/language');

const fizLanguage = language.LRLanguage.define({
    parser: lezerFiz.parser.configure({
        props: [
            language.indentNodeProp.add({
                ArgList: language.delimitedIndent({ closing: ")", align: false }),
                StyleArgList: language.delimitedIndent({ closing: "}", align: false }),
                StatementList: language.delimitedIndent({ closing: "]", align: false }),
            }),
            language.foldNodeProp.add({
                ArgList: language.foldInside,
                StyleArgList: language.foldInside,
                StatementList: language.foldInside,
                BlockComment(tree) {
                    return { from: tree.from + 2, to: tree.to - 2 };
                },
            }),
        ],
    }),
    languageData: {
        closeBrackets: { brackets: ["(", "{", "[", "'", '"'] },
        commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    },
});
function fiz() {
    return new language.LanguageSupport(fizLanguage);
}

exports.fiz = fiz;
exports.fizLanguage = fizLanguage;
