import { parser } from '@formulavize/lezer-fiz';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';

const fizLanguage = /*@__PURE__*/LRLanguage.define({
    parser: /*@__PURE__*/parser.configure({
        props: [
            /*@__PURE__*/indentNodeProp.add({
                ArgList: /*@__PURE__*/delimitedIndent({ closing: ")", align: false }),
                StyleArgList: /*@__PURE__*/delimitedIndent({ closing: "}", align: false }),
                StatementList: /*@__PURE__*/delimitedIndent({ closing: "]", align: false }),
            }),
            /*@__PURE__*/foldNodeProp.add({
                ArgList: foldInside,
                StyleArgList: foldInside,
                StatementList: foldInside,
                BlockComment(tree) {
                    return { from: tree.from + 2, to: tree.to - 2 };
                },
            }),
        ],
    }),
    languageData: {
        closeBrackets: { brackets: ["(", "{", "[", "'", '"'] },
        commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    },
});
function fiz() {
    return new LanguageSupport(fizLanguage);
}

export { fiz, fizLanguage };
